From 830eff2681a0aa596a1e02319806ae8ab9ad6594 Mon Sep 17 00:00:00 2001
From: Kalle Valo <kvalo@codeaurora.org>
Date: Mon, 3 Oct 2016 14:15:20 +0300
Subject: [PATCH 3/4] stubs: stg: make it possible to fail stg import

Needed for testing pwcli.

Also fix a bug in class StubContext() there we accidentally overwrote
self.stgit with None and that made it impossible to use it from scripts.

Signed-off-by: Kalle Valo <kvalo@codeaurora.org>
---

Copyright (c) 2016, The Linux Foundation.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

3. Neither the name of the copyright holder nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 cmdtests/cmdtestlib.py    |    2 +-
 stubs/cmdtests/stg.script |   10 ++++++++++
 stubs/cmdtests/stg.stdout |    2 ++
 stubs/stg                 |    8 ++++++++
 stubs/stubs.py            |   18 ++++++++++++++++++
 5 files changed, 39 insertions(+), 1 deletion(-)

diff --git a/cmdtests/cmdtestlib.py b/cmdtests/cmdtestlib.py
index 13da9fc5fb81..d11ca216b49b 100644
--- a/cmdtests/cmdtestlib.py
+++ b/cmdtests/cmdtestlib.py
@@ -115,7 +115,7 @@ class StubContext():
 
             if self.stgit:
                 stgit = True
-                self.stgit = self.stgit.start()
+                self.stgit.start()
 
             self.smtpd.start()
             self.patchwork.start()
diff --git a/stubs/cmdtests/stg.script b/stubs/cmdtests/stg.script
index ba380ad964c8..ff5b04888693 100755
--- a/stubs/cmdtests/stg.script
+++ b/stubs/cmdtests/stg.script
@@ -60,6 +60,8 @@ def stg_import(filename):
 
       (stdoutdata, stderrdata) = p.communicate(input=buf)
 
+      return p.returncode
+
 def main():
       os.chdir(datadir)
 
@@ -92,6 +94,14 @@ def main():
 
       print 'test show'
       subprocess.call([stub_stg, 'show', 'foo-test-2'])
+
+      print 'import should fail'
+      stgstub.set_import_failure(True)
+      returncode = stg_import('1002-review-foo-test-2.patch')
+      if returncode != 2:
+            print 'wrong return code: %d' % (returncode)
+            sys.exit(1)
+      print
       
       # cleanup
       stgstub.cleanup()
diff --git a/stubs/cmdtests/stg.stdout b/stubs/cmdtests/stg.stdout
index c257b6b70af0..0f7732e75f18 100644
--- a/stubs/cmdtests/stg.stdout
+++ b/stubs/cmdtests/stg.stdout
@@ -30,3 +30,5 @@ Date:   2011-02-11 15:23:31
    
    ---
    FIXME: add the patch here
+import should fail
+
diff --git a/stubs/stg b/stubs/stg
index 0a0bb39bfba9..b19e4f131a9a 100755
--- a/stubs/stg
+++ b/stubs/stg
@@ -59,6 +59,10 @@ patchesfile = None
 #
 # StgStub.get_patches(): patches['foo-patch-name'] = '<full patch>'
 
+IMPORT_FAIL = 'import-fail'
+
+IMPORT_FAILED_MSG = 'error: patch failed: drivers/net/wireless/foo/core.c:1714\nerror: drivers/net/wireless/foo/core.c: patch does not apply\nerror: patch failed: drivers/net/wireless/foo/core.h:635\nerror: drivers/net/wireless/foo/core.h: patch does not apply\nerror: patch failed: drivers/net/wireless/foo/debug.c:1427\nerror: drivers/net/wireless/foo/debug.c: patch does not apply\nerror: patch failed: drivers/net/wireless/foo/debug.h:59\nerror: drivers/net/wireless/foo/debug.h: patch does not apply\nerror: patch failed: drivers/net/wireless/foo/mac.c:6924\nerror: drivers/net/wireless/foo/mac.c: patch does not apply\nstg import: Diff does not apply cleanly\n'
+
 def get_patches():
       patches = {}
 
@@ -130,6 +134,10 @@ def cmd_import(args):
       buf_cleaned = re.sub(r'^From nobody.*\n', 'From nobody\n', buf)
       commit_id = hashlib.sha1(buf_cleaned).hexdigest()
 
+      if os.path.exists(os.path.join(stgdir, IMPORT_FAIL)):
+            sys.stderr.write(IMPORT_FAILED_MSG)
+            sys.exit(2)
+
       f = open(patchesfile, 'a')
       f.write('%s\t%s\n' % (commit_id, patch_name))
       f.close()
diff --git a/stubs/stubs.py b/stubs/stubs.py
index 5599e7e784fc..03ab081a0c53 100644
--- a/stubs/stubs.py
+++ b/stubs/stubs.py
@@ -127,6 +127,8 @@ class BuilderStub():
         return count
 
 class StgStub():
+    IMPORT_FAIL = 'import-fail'
+
     def __init__(self):
         self.gitdir = os.path.join(testdatadir, 'git')
         self.objectsdir = os.path.join(self.gitdir, 'objects')
@@ -214,6 +216,22 @@ class StgStub():
 
         return msgs
 
+    def set_import_failure(self, enabled):
+        path = os.path.join(self.stgdir, self.IMPORT_FAIL)
+        if enabled:
+            f = open(path, 'w')
+            f.write('1')
+            f.close()
+        else:
+            try:
+                os.remove(path)
+            except OSError:
+                pass
+
+    def get_import_failure(self, enabled):
+        path = os.path.join(self.stgdir, self.IMPORT_FAIL)
+        return os.path.exists(path)
+
 class GitStub():
     def __init__(self, smtpport=SMTP_PORT):
         self.gitdir = os.path.join(testdatadir, 'git')
-- 
1.7.9.5

